/*******************************************************************************
 *
 *        Program : global.h
 *
 *        Author  : Kim, Dongmin (kimd@top.cis.syr.edu)
 *
 *        The global variables for prs.c
 *
 *******************************************************************************/

#define Max   4096
#define fail  0
#define null  0
#define true  1
#define false 0

#define msg_size      4        /* integer */
#define Rankmax       2
#define Bufmax        Max
#define Procmax       32       /* Maximum number of processor on each dim*/

#define IMax 16    /* 16 = log(V_Lmax) */

/******************************************************************************
                     Definition of Type
 ******************************************************************************/
 
typedef int Datatype; /* data type for array */

typedef int Gindex;   /* for global index */

typedef int Lindex;   /* for local index */

typedef int Pindex;   /* for processor index */

/*******************************************************************************
 *                                                                             *
 *   Global variables                                                          *
 *                                                                             *
 *******************************************************************************/

int    my_pnum;            /* The ID of the Processor */
int    my_id;              /* The ID of the selected dim in the converted ID */
int    ori_nproc;          /* Number of available  processors */
int    tot_nproc;          /* Total number of processors */
int    tot_dproc;          /* dimension of tot_nproc */
int    direction;          /* the direction to communicate */
int    dir_nproc;          /* Totol number of processors in the selected dim */
Gindex rank;               /* rank */

int    v_size; /* Vector Size */
int    digit;  /* binary digit */

int    my_grid[Rankmax];    /* converted ID */
int    nproc[Rankmax];     /* Total number of processors on each dims */
int    dproc[Rankmax];     /* Total dimension of processors */

int    partner_grid[Rankmax];   /* The processor ID with which the data 
				   is exchanged */
int    right_grid[Rankmax];     /* The processor ID of right child */
int    parent_grid[Rankmax];    /* The processor ID of parent */

int    partner_pnum;
int    right_pnum;
int    parent_pnum;

int    width[Rankmax];     /* Width of partition within a single tile */

int    L[Rankmax];         /* Locall Domain size */


int    Left[IMax][Max];  /* Sums from right child process by step.
			     1st dimension is for step, and
			     2nd dimension is for the sums
			     from the left child process.          */

int    in_mesg[Max];      /* received data */
int    out_mesg[Max];     /* send data */
